#include "interpreter.h"
#include "ast.h"
#include "log.h"

#include <stdlib.h>
#include <string.h>

char *
object_to_str(struct object *obj)
{
	if (obj->type == OBJECT_TYPE_STRING) {
		return obj->string.data;
	}

	return NULL;
}

struct object *
eval_meson_object(struct context *ctx, struct ast_function *function)
{
	struct ast_identifier *id = function->left;

	struct object *obj = NULL;

	if (strcmp(id->data, "project_version") == 0) {
		obj = calloc(1, sizeof(struct object));
		if (!obj) {
			fatal("failed to allocate string object");
		}

		obj->type = OBJECT_TYPE_STRING;

		obj->string.data = strdup(ctx->version.data);
		obj->string.n = ctx->version.n;
	}

	return obj;
}

